#ifndef EFL_LOOP_USER_EO_HH
#define EFL_LOOP_USER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_loop.eo.h"
#include "efl_loop_user.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_loop.eo.hh"
#include "eo_base.eo.hh"
namespace efl { 
struct Loop_User;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Loop_User> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { 
struct Loop_User {
   ::efl::eolian::return_traits< ::efl::Loop>::type loop_get() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_LOOP_USER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Loop_User() const;
   operator ::efl::Loop_User&();
   operator ::efl::Loop_User const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Loop_User,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Loop_User const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Loop_User : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Loop_User( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Loop_User(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Loop_User(Loop_User const& other) = default;
   Loop_User(Loop_User&& other) = default;
   Loop_User& operator=(Loop_User const& other) = default;
   Loop_User& operator=(Loop_User&& other) = default;
   Loop_User()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Loop_User( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Loop_User(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::Loop>::type loop_get() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_LOOP_USER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Loop_User,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Loop_User const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Loop_User) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Loop_User>::value, "");
} 
#include "efl_loop_user.eo.impl.hh"
#endif
